local clothing = {
    poncho = 0xE5BD82FE,
    vest = 0x22A9C876,
    mask = 0x9BC331EF,
    shirt = 0x8D6EC0EF,
    pants = 0x41DE8DBD,
    suspenders = 0x1CB2B388,
    spurs = 0x4F66D869,
    spats = 0xC26BC6DD,
    eyewear = 0xD4EAF7A9,
    beltbuckle = 0xC9EE847B,
    ringsleft = 0xD2E24E5A,
    ringsright = 0xCE767113,
    belt = 0x14F78CE7,
    gunbelt = 0x873600C6,
    offhand = 0x82A9BA92,
    gunaccs = 0xF4BCFD28,
    satchel = 0xEE49F9B6,
    coat = 0x57C74BBC,
    cloak = 0xF16EC55D,
    necktie = 0x6A9D0CF5,
    chaps = 0x0847FFD8,
    bracelet = 0xF799F1B5,
    gauntlets = 0x166A3B1B,
    bandana = 0xE8BD99CB,
    accessories = 0x361F17DA,
    boots = 0x191B28F3,
    gloves = 0xF27A5EE2,
    loadout = 0xF5AEA30E,
    hat = 0xEBDD6373
}

local playerPedComponents = {
    skin = {
        MouthSizeY = 1.0,
        EyePositionX = 1.0,
        NoseSizeX = 1.0,
        BrowShapeY = 1.0,
        Hair = 3676725024,
        EyeSizeY = 1.0,
        LowerLipSizeY = 1.0,
        EarPositionY = 1.0,
        UpperLipSizeX = 1.0,
        EyeType = 329402181,
        HeadType = 400853596,
        NoseSizeY = 1.0,
        EarlobeSize = 1.0,
        NosePositionX = 1.0,
        BrowDepth = 1.0,
        UpperLipDepth = 1.0,
        EyeSizeX = 1.0,
        JawDepth = 2.0,
        JawPositionY = 2.0,
        BrowShapeX = 1.0,
        UpperLipSizeY = 1.0,
        Waist = -2045421226,
        EyeDepth = 1.0,
        BodyType = 32611963,
        LowerLipDepth = 1.0,
        MouthSizeX = 1.0,
        EyeAngle = 1.0,
        Sex = 0,
        MouthPositionX = 1.0,
        Teeth = 712446626,
        LowerLipSizeX = 1.0,
        NoseAngleX = 0.83999999999999,
        ChinDepth = 2.0,
        EarAngle = 1.0,
        CheekboneDepth = 2.0,
        HeadWidth = 2.0,
        CheekbonePositionX = 2.0,
        TorsoType = 1180660122,
        Beard = 1658715876,
        ChinPositionX = 2.0,
        NoseAngleY = 1.0,
        MouthPositionY = 1.0,
        NosePositionY = 1.0,
        LegType = 1694074219,
        CheekbonePositionY = 2.0,
        ChinPositionY = 2.0,
        OverallSize = 0.997,
        JawPositionX = 2.0,
        EarPositionX = 1.0,
        EyePositionY = 1.0
    },
    overlays = {{
        visibility = 1,
        tx_opacity = 1.0,
        name = "Wrinkles",
        tx_unk = 0,
        tx_material = 0,
        opacity = 1.0,
        tx_normal = 0,
        tx_color_type = 1,
        var = 0,
        tx_id = 1839055877
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "Eyebrows",
        palette_color_tertiary = 0,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 0,
        tx_material = 0,
        opacity = 1.0,
        var = 0,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 0,
        tx_id = 176409198
    }, {
        visibility = 1,
        tx_opacity = 1.0,
        name = "Scars",
        tx_unk = 0,
        tx_material = 0,
        opacity = 1.0,
        tx_normal = 0,
        tx_color_type = 1,
        var = 0,
        tx_id = 2430102340
    }, {
        visibility = 1,
        tx_opacity = 1.0,
        name = "Freckles",
        tx_unk = 0,
        tx_material = 0,
        opacity = 1.0,
        tx_normal = 0,
        tx_color_type = 1,
        var = 0,
        tx_id = 700442846
    }, {
        visibility = 1,
        tx_opacity = 1.0,
        name = "Moles",
        tx_unk = 0,
        tx_material = 0,
        opacity = 1.0,
        tx_normal = 0,
        tx_color_type = 1,
        var = 0,
        tx_id = 3443058344
    }, {
        visibility = 1,
        tx_opacity = 1.0,
        name = "Spots",
        tx_unk = 0,
        tx_material = 0,
        opacity = 1.0,
        tx_normal = 0,
        tx_color_type = 1,
        var = 0,
        tx_id = 1709967951
    }, {
        visibility = 1,
        tx_opacity = 1.0,
        name = "Mottling",
        tx_unk = 0,
        tx_material = 0,
        opacity = 1.0,
        tx_normal = 0,
        tx_color_type = 1,
        var = 0,
        tx_id = 3805247428
    }, {
        visibility = 1,
        tx_opacity = 1.0,
        name = "Blemishes",
        tx_unk = 0,
        tx_material = 0,
        opacity = 1.0,
        tx_normal = 0,
        tx_color_type = 1,
        var = 0,
        tx_id = 1073447149
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "BeardStubble",
        palette_color_tertiary = 0,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 0,
        tx_material = 0,
        opacity = 1.0,
        var = 0,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 0,
        tx_id = 928860167
    }, {
        name = "ShavedHead",
        var = 0,
        opacity = 1.0,
        tx_id = 1
    }, {
        tx_id = 2559915222,
        name = "SkinTone"
    }, {
        tx_id = 207556545,
        name = "Complexion"
    }},
    makeup = {{
        visibility = 1,
        palette = 1064202495,
        name = "Foundation",
        palette_color_tertiary = 0,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 1,
        tx_material = 0,
        opacity = 1.0,
        var = 1,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 0,
        tx_id = 4015698560
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "Eyeliner",
        palette_color_tertiary = 0,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 0,
        tx_material = 0,
        opacity = 1.0,
        var = 1,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 0,
        tx_id = 698541455
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "Eyeshadow",
        palette_color_tertiary = 1,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 1,
        tx_material = 0,
        opacity = 1.0,
        var = 1,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 1,
        tx_id = 1203597961
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "Lipstick",
        palette_color_tertiary = 0,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 1,
        tx_material = 0,
        opacity = 1.0,
        var = 1,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 1,
        tx_id = 2289963488
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "Small Blush",
        palette_color_tertiary = 0,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 1,
        tx_material = 0,
        opacity = 1.0,
        var = 1,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 0,
        tx_id = 1197569109
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "Higher Blush",
        palette_color_tertiary = 1,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 1,
        tx_material = 0,
        opacity = 1.0,
        var = 1,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 1,
        tx_id = 290261037
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "Full Blush",
        palette_color_tertiary = 1,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 1,
        tx_material = 0,
        opacity = 1.0,
        var = 1,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 1,
        tx_id = 1840529658
    }, {
        visibility = 1,
        palette = 1064202495,
        name = "Line of Blush",
        palette_color_tertiary = 1,
        tx_unk = 0,
        tx_opacity = 1.0,
        palette_color_primary = 1,
        tx_material = 0,
        opacity = 1.0,
        var = 1,
        tx_normal = 0,
        tx_color_type = 0,
        palette_color_secondary = 1,
        tx_id = 3966713458
    }}
}

FaceComponent = {
    [1]  = {['name']='Eye Color',                                                                },
    [2]  = {['name']='BrowShape',         ['x']=0.0,['y']=0.0, ['xhash']=0x2FF9, ['yhash']=0x3303},
    [3]  = {['name']='BrowDepth',         ['x']=0.0,           ['xhash']=0x4AD1                  },
    [4]  = {['name']='EyeAngle',          ['x']=0.0,           ['xhash']=0xD266                  },
    [5]  = {['name']='EyeDepth',          ['x']=0.0,           ['xhash']=0xEE44                  },
    [6]  = {['name']='EyePosition',       ['x']=0.0,['y']=0.0, ['xhash']=0xA54E, ['yhash']=0xDDFB},
    [7]  = {['name']='EyeSize',           ['x']=0.0,['y']=0.0, ['xhash']=0x1B6B, ['yhash']=0x8B2B},
    [8]  = {},
  
    [9]  = {['name']='HeadWidth',         ['x']=0.0,           ['xhash']=0x84D6                  },
    [10] = {['name']='CheekbonePosition', ['x']=0.0,['y']=0.0,['xhash']=0xABCF, ['yhash']=0x6A0B},
    [11] = {['name']='CheekboneDepth',    ['x']=0.0,           ['xhash']=0x358D                  },
    [12] = {['name']='JawPosition',       ['x']=0.0,['y']=0.0, ['xhash']=0xEBAE, ['yhash']=0x8D0A},
    [13] = {['name']='JawDepth',          ['x']=0.0,           ['xhash']=0x1DF6                  },
    [14] = {['name']='ChinPosition',      ['x']=0.0,['y']=0.0, ['xhash']=0xC3B2, ['yhash']=0x3C0F},
    [15] = {['name']='ChinDepth',         ['x']=0.0,           ['xhash']=0xE323                  },
    [16] = {},
  
    [17] = {['name']='EarPosition',       ['x']=0.0,['y']=0.0, ['xhash']=0xC04F, ['yhash']=0x2844},
    [18] = {['name']='EarAngle',          ['x']=0.0,           ['xhash']=0xB6CE                  },
    [19] = {['name']='EarlobeSize',       ['x']=0.0,           ['xhash']=0xED30                  },
    [20] = {['name']='NosePosition',      ['x']=0.0,['y']=0.0, ['xhash']=0x6E7F, ['yhash']=0x03F5},
    [21] = {['name']='NoseSize',          ['x']=0.0,['y']=0.0, ['xhash']=0x3471, ['yhash']=0x561E},
    [22] = {['name']='NoseAngle',         ['x']=0.0,['y']=0.0, ['xhash']=0xF156, ['yhash']=0x34B1},
    [23] = {},
  
    [24] = {['name']='MouthSize',         ['x']=0.0,['y']=0.0, ['xhash']=0xF065, ['yhash']=0xAA69},
    [25] = {['name']='MouthPosition',     ['x']=0.0,['y']=0.0, ['xhash']=0x7AC3, ['yhash']=0x410D},
    [26] = {['name']='UpperLipSize',      ['x']=0.0,['y']=0.0, ['xhash']=0x91C1, ['yhash']=0x1A00},
    [27] = {['name']='UpperLipDepth',     ['x']=0.0,           ['xhash']=0xC375                  },
    [28] = {['name']='LowerLipSize',      ['x']=0.0,['y']=0.0, ['xhash']=0xB0B0, ['yhash']=0xBB40},
    [29] = {['name']='LoweLipDepth',      ['x']=0.0,           ['xhash']=0x5D16                  },
    [30] = {['name']='Teeth',                                                                    },
    [31] = {}
  }

function loadClothing()
    local playerPed = PlayerPedId()
    function EnableComponent(hash)
        Citizen.InvokeNative(0x704C908E9C405136, playerPed)
        Citizen.InvokeNative(0xD3A7B003ED343FD9 , playerPed,  hash, true, true, true)
    end

    
    if component == 'all' then
        EnableComponent(clothing.mask)
        EnableComponent(clothing.hat)
        EnableComponent(clothing.shirt)
        EnableComponent(clothing.vest)
        EnableComponent(clothing.pants)
        EnableComponent(clothing.gunbelt)
        EnableComponent(clothing.belt)
        EnableComponent(clothing.beltbuckle)
        EnableComponent(clothing.offhand)
        EnableComponent(clothing.loadout)
        EnableComponent(clothing.suspenders)
        EnableComponent(clothing.spurs)
        EnableComponent(clothing.accessories)
        EnableComponent(clothing.cloak)
        EnableComponent(clothing.necktie)
        EnableComponent(clothing.eyewear)
        EnableComponent(clothing.chaps)
        EnableComponent(clothing.spats)
        EnableComponent(clothing.boots)
        EnableComponent(clothing.gloves)
        EnableComponent(clothing.gauntlets)
        EnableComponent(clothing.bandana)
        EnableComponent(clothing.coat)
        EnableComponent(clothing.poncho)
        EnableComponent(clothing.ringsright)
        EnableComponent(clothing.ringsleft)
        EnableComponent(clothing.satchel)
        EnableComponent(clothing.bracelet)
        EnableComponent(clothing.gunaccs)
    elseif component == 'mask' then
        EnableComponent(clothing.mask)
    elseif component == 'hat' then
        EnableComponent(clothing.hat)
    elseif component == 'shirt' then
        EnableComponent(clothing.shirt)
    elseif component == 'vest' then
        EnableComponent(clothing.vest)
    elseif component == 'pants' then
        EnableComponent(clothing.pants)
    elseif component == 'gunbelt' then
        EnableComponent(clothing.gunbelt)
    elseif component == 'belt' then
        EnableComponent(clothing.belt)
    elseif component == 'beltbuckle' then
        EnableComponent(clothing.beltbuckle)
    elseif component == 'offhand' then
        EnableComponent(clothing.offhand)
    elseif component == 'loadout' then
        EnableComponent(clothing.loadout)
    elseif component == 'suspenders' then
        EnableComponent(clothing.suspenders)
    elseif component == 'spurs' then
        EnableComponent(clothing.spurs)
    elseif component == 'accessories' then
        EnableComponent(clothing.accessories)
    elseif component == 'cloak' then
        EnableComponent(clothing.cloak)
    elseif component == 'necktie' then
        EnableComponent(clothing.necktie)
    elseif component == 'eyewear' then
        EnableComponent(clothing.eyewear)
    elseif component == 'chaps' then
        EnableComponent(clothing.chaps)
    elseif component == 'spats' then
        EnableComponent(clothing.spats)
    elseif component == 'boots' then
        EnableComponent(clothing.boots)
    elseif component == 'gloves' then
        EnableComponent(clothing.gloves)
    elseif component == 'gauntlets' then
        EnableComponent(clothing.gauntlets)
    elseif component == 'bandana' then
        EnableComponent(clothing.bandana)
    elseif component == 'coat' then
        EnableComponent(clothing.coat)
    elseif component == 'poncho' then
        EnableComponent(clothing.poncho)
    elseif component == 'ringsright' then
        EnableComponent(clothing.ringsright)
    elseif component == 'ringsleft' then
        EnableComponent(clothing.ringsleft)
    elseif component == 'satchel' then
        EnableComponent(clothing.satchel)
    elseif component == 'bracelet' then
        EnableComponent(clothing.bracelet)
    elseif component == 'gunaccs' then
        EnableComponent(clothing.gunaccs)
    end
end

function createPlayerPed()
    -------------------------------
    --     Spawn Base Ped        --
    -------------------------------
    local maleModel = GetHashKey("mp_male")
    if not HasModelLoaded(maleModel) then
        RequestModel(maleModel, false)
    end
    while not HasModelLoaded(maleModel) do
        Wait(10)
    end
    local ped = PlayerPedId()

    SetPlayerModel(PlayerId(), maleModel, true)
    while PlayerPedId() == ped do
        Wait(10)
    end
    local playerPed = PlayerPedId()
    SetModelAsNoLongerNeeded(maleModel)
    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0) --refresh ped

    SetPedOutfitPreset(playerPed, 4, false)

    -------------------------------
    --      Apply Overlays       --
    -------------------------------
    function overlayChange(components)
        local ped = PlayerPedId()
        local overlayLayers = overlay_all_layers
        local makeupLayers = overlay_makeup_layers
        if components then
            if components.overlays then
                overlayLayers = components.overlays
            end
            if components.makeup then
                makeupLayers = components.makeup
            end
        end
        for k,v in ipairs(overlayLayers) do
            if v.name=='SkinTone' then
                SkinToneId=v.tx_id
            elseif v.name=='Complexion' then
                Complexion=v.tx_id
            end
        end
        current_texture_settings = {
            albedo=GetHashKey("mp_head_mr1_sc00_c0_000_ab"),
            normal=GetHashKey("mp_head_mr1_000_nm"),
            material=0x50A4BBA9,
            color_type=1,
            texture_opacity=1.0,
            unk_arg=0,
        }
        if textureId ~= -1 then
            Citizen.InvokeNative(0xB63B9178D0F58D82,textureId)  -- reset texture
            Citizen.InvokeNative(0x6BEFAA907B076859,textureId)  -- remove texture
        end
        textureId = Citizen.InvokeNative(0xC5E7204F322E49EB, SkinToneId, Complexion, current_texture_settings.material);  -- create texture
        timer = 30
        while (textureId == -1 or textureId == nil) and timer >= 0 do
            Wait(50)
            timer = timer - 1
            if timer % 5 then
                print('refreshing texture:'..tostring(textureId))
                textureId = Citizen.InvokeNative(0xC5E7204F322E49EB, SkinToneId, Complexion, current_texture_settings.material);  -- create texture
                Citizen.InvokeNative(0x92DAABA2C1C10B0E,textureId)  -- update texture
                Citizen.InvokeNative(0xB63B9178D0F58D82,textureId)  -- reset texture
                Citizen.InvokeNative(0x6BEFAA907B076859,textureId)  -- remove texture
            end
        end
        for k,v in pairs(overlayLayers) do
            if (v.name == 'BeardStubble' or v.name == 'ShavedHead') and v.visibility == 0 then
                v.visibility = 1
                v.tx_id = 1
            end
            if v.visibility ~= 0 and v.name ~= 'SkinTone' and v.name ~= 'Complexion' then
                if v.name ~= 'BeardStubble' and v.name ~= 'ShavedHead' and v.name ~= 'Eyebrows' then
                    local overlay_id = Citizen.InvokeNative(0x86BB5FF45F193A02,textureId, v.tx_id , v.tx_normal, v.tx_material, 1, v.opacity,0); -- create overlay
                else
                    local overlay_id = Citizen.InvokeNative(0x86BB5FF45F193A02,textureId, v.tx_id , v.tx_normal, v.tx_material, 0, v.opacity,0); -- create overlay
                    Citizen.InvokeNative(0x1ED8588524AC9BE1,textureId,overlay_id,v.palette);     -- apply palette
                    Citizen.InvokeNative(0x2DF59FFE6FFD6044,textureId,overlay_id,0,0,0)  -- apply palette colours
                end
                Citizen.InvokeNative(0x3329AAE2882FC8E4,textureId,overlay_id, 0);     -- apply overlay variant
                Citizen.InvokeNative(0x6C76BC24F8BB709A,textureId,overlay_id, v.opacity); -- apply overlay opacity
            end
        end
        for k,v in pairs(makeupLayers) do
            if v.visibility ~= 0 then
                local overlay_id = Citizen.InvokeNative(0x86BB5FF45F193A02,textureId, v.tx_id , v.tx_normal, v.tx_material, 0, v.tx_opacity,0); -- create overlay
                Citizen.InvokeNative(0x1ED8588524AC9BE1,textureId,overlay_id,v.palette);    -- apply palette
                Citizen.InvokeNative(0x2DF59FFE6FFD6044,textureId,overlay_id,v.palette_color_primary,v.palette_color_secondary,v.palette_color_tertiary)  -- apply palette colours

                Citizen.InvokeNative(0x3329AAE2882FC8E4,textureId,overlay_id, v.var);     -- apply overlay variant
                Citizen.InvokeNative(0x6C76BC24F8BB709A,textureId,overlay_id, v.opacity); -- apply overlay opacity
            end
        end
        timer = 30
        while ((Citizen.InvokeNative(0x31DC8D3F216D8509, textureId)) == false or (Citizen.InvokeNative(0x31DC8D3F216D8509, textureId)) == -1) and timer >= 0 do
            Wait(100)
            timer = timer - 1
        end
        Citizen.InvokeNative(0x0B46E25761519058,ped,GetHashKey("heads"),textureId)    -- apply texture to current component in category "heads"
        Wait(50)
        Citizen.InvokeNative(0x92DAABA2C1C10B0E,textureId)                -- update texture
        Wait(50)
        Citizen.InvokeNative(0x704C908E9C405136, ped)
        Citizen.InvokeNative(0xCC8CA3E88256E58F,ped, 0, 1, 1, 1, false);  -- refresh ped components
    end

    overlayChange(playerPedComponents)
    playerPed = PlayerPedId()

    Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x662AC34, 0)
    Citizen.InvokeNative(0x704C908E9C405136, playerPed)
    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0)

    Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x485EE834, 0)
    Citizen.InvokeNative(0x704C908E9C405136, playerPed)
    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0)

    Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x2026C46D, 0)
    Citizen.InvokeNative(0x704C908E9C405136, playerPed)
    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0)

    Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x1D4C528A, 0)
    Citizen.InvokeNative(0x704C908E9C405136, playerPed)
    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0)

    Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xEABE0032, 0)
    Citizen.InvokeNative(0x704C908E9C405136, playerPed)
    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0)

    Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xE06D30CE, 0)
    Citizen.InvokeNative(0x704C908E9C405136, playerPed)
    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0)

    Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x777EC6EF, 0)
    Citizen.InvokeNative(0x704C908E9C405136, playerPed)
    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0)

    -------------------------------
    --Apply Saved Body Componets --
    -------------------------------
    Citizen.InvokeNative(0x1902C4CFCC5BE57C,playerPed, math.floor(playerPedComponents.skin.BodyType),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    Citizen.InvokeNative(0xD3A7B003ED343FD9,playerPed, math.floor(playerPedComponents.skin.HeadType),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    Citizen.InvokeNative(0xD3A7B003ED343FD9,playerPed, math.floor(playerPedComponents.skin.TorsoType),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    Citizen.InvokeNative(0xD3A7B003ED343FD9,playerPed, math.floor(playerPedComponents.skin.LegType),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    Citizen.InvokeNative(0x1902C4CFCC5BE57C,playerPed, math.floor(playerPedComponents.skin.Waist),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    Citizen.InvokeNative(0xD3A7B003ED343FD9,playerPed, math.floor(playerPedComponents.skin.EyeType),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    Citizen.InvokeNative(0xD3A7B003ED343FD9,playerPed, tonumber(playerPedComponents.skin.Teeth),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    if playerPedComponents.skin.Hair == -1 then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x864B03AE , 1) --Target Hair
        Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, 0)  --Remove Hair
    else
        Citizen.InvokeNative(0xD3A7B003ED343FD9,playerPed, math.floor(playerPedComponents.skin.Hair),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    end
    Citizen.InvokeNative(0xD3A7B003ED343FD9,playerPed, math.floor(playerPedComponents.skin.Beard),true,true,true)
    while Citizen.InvokeNative(0xA0BC8FAED8CFEB3C,playerPed) == false do
        Wait(10)
    end
    Citizen.InvokeNative(0x704C908E9C405136,playerPed) --also refreshesped?
    Citizen.InvokeNative(0xCC8CA3E88256E58F,playerPed, false, true, true, true, false)

    SetPedScale(playerPed, tonumber(string.format("%.2f",playerPedComponents.skin.OverallSize)))


    -------------------------------
    --   Apply Face Components   --
    -------------------------------
    --Brow & Eyes
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 2].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.BrowShapeX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 2].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.BrowShapeY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 3].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.BrowDepth)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 4].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.EyeAngle)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 5].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.EyeDepth)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 6].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.EyePositionX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 6].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.EyePositionY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 7].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.EyeSizeX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 7].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.EyeSizeY)))
    --Cheeks, Jaw, & Chin
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[ 9].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.HeadWidth)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[10].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.CheekbonePositionX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[10].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.CheekbonePositionY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[11].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.CheekboneDepth)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[12].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.JawPositionX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[12].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.JawPositionY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[13].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.JawDepth)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[14].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.ChinPositionX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[14].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.ChinPositionY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[15].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.ChinDepth)))
    --Ear & Nose
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[17].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.EarPositionX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[17].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.EarPositionY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[18].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.EarAngle)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[19].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.EarlobeSize)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[20].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.NosePositionX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[20].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.NosePositionY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[21].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.NoseSizeX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[21].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.NoseSizeY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[22].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.NoseAngleX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[22].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.NoseAngleY)))
    --Mouth & Lips
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[24].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.MouthSizeX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[24].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.MouthSizeY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[25].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.MouthPositionX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[25].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.MouthPositionY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[26].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.UpperLipSizeX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[26].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.UpperLipSizeY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[27].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.UpperLipDepth)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[28].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.LowerLipSizeX)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[28].yhash, tonumber(string.format("%.2f",playerPedComponents.skin.LowerLipSizeY)))
    Citizen.InvokeNative(0x5653AB26C82938CF,playerPed, FaceComponent[29].xhash, tonumber(string.format("%.2f",playerPedComponents.skin.LowerLipDepth)))

    overlayChange(playerPedComponents)
end

RegisterCommand('createplayerped', function(source, args)
    createPlayerPed()
end)

RegisterCommand('loadclothing', function(source, args)
    component = args[1] and args[1] or 'all'
    loadClothing(component)
end)

RegisterCommand('removeclothing', function(source, args)
    local playerPed = PlayerPedId()
    component = args[1] and args[1] or 'all'
    if component == 'all' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x7505EF42, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x9925C067, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x2026C46D, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x485EE834, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x1D4C528A, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x9B2C8B89, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xA6D134C6, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xFAE9107F, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xB6B6122D, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x83887E88, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x877A2CF7, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x18729F39, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x79D7DF96, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x3C1A74CD, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x7A96FACA, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x5E47CA6, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x3107499B, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x514ADCEA, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x777EC6EF, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xEABE0032, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x91CE9B20, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x5FC29285, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x662AC34, 0)
        Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, false)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xE06D30CE, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xAF14310B, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x7A6BBD0B, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xF16A1D23, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x94504D26, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x7BC10759, 0)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xF1542D11, 0)
    elseif component == 'mask' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x7505EF42, 0)
    elseif component == 'hat' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x9925C067, 0)
    elseif component == 'shirt' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x2026C46D, 0)
    elseif component == 'vest' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x485EE834, 0)
    elseif component == 'pants' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x1D4C528A, 0)
    elseif component == 'gunbelt' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x9B2C8B89, 0)
    elseif component == 'belt' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xA6D134C6, 0)
    elseif component == 'beltbuckle' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xFAE9107F, 0)
    elseif component == 'offhand' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xB6B6122D, 0)
    elseif component == 'loadout' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x83887E88, 0)
    elseif component == 'suspenders' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x877A2CF7, 0)
    elseif component == 'spurs' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x18729F39, 0)
    elseif component == 'accessories' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x79D7DF96, 0)
    elseif component == 'cloak' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x3C1A74CD, 0)
    elseif component == 'necktie' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x7A96FACA, 0)
    elseif component == 'eyewear' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x5E47CA6, 0)
    elseif component == 'chaps' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x3107499B, 0)
    elseif component == 'spats' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x514ADCEA, 0)
    elseif component == 'boots' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x777EC6EF, 0)
    elseif component == 'gloves' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xEABE0032, 0)
    elseif component == 'gauntlets' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x91CE9B20, 0)
    elseif component == 'bandana' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x5FC29285, 0)
    elseif component == 'coat' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x662AC34, 0)
        Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, false)
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xE06D30CE, 0)
    elseif component == 'poncho' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xAF14310B, 0)
    elseif component == 'ringsright' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x7A6BBD0B, 0)
    elseif component == 'ringsleft' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xF16A1D23, 0)
    elseif component == 'satchel' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x94504D26, 0)
    elseif component == 'bracelet' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0x7BC10759, 0)
    elseif component == 'gunaccs' then
        Citizen.InvokeNative(0xD710A5007C2AC539, playerPed, 0xF1542D11, 0)
    end

    Citizen.InvokeNative(0xCC8CA3E88256E58F, playerPed, 0, 1, 1, 1, false)
end)

RegisterCommand("loadout", function(source, args, rawCommand)
    Citizen.CreateThread(function()
        local player = PlayerPedId()
        GiveWeaponToPed_2(player, GetHashKey('WEAPON_MELEE_KNIFE'), 0, false, true, 4, true)
        Citizen.Wait(50)
        GiveWeaponToPed_2(player, GetHashKey('WEAPON_THROWN_THROWING_KNIVES'), 8, false, true, 6, true)
        Citizen.Wait(50)
        GiveWeaponToPed_2(player, GetHashKey('WEAPON_BOW'), 20, false, true, 7, true)
        Citizen.Wait(50)
        Citizen.InvokeNative(0x106A811C6D3035F3, player, GetHashKey('AMMO_ARROW_DYNAMITE'), 100, GetHashKey(ADD_REASON_PICKUP)) --AddAmmoToPedByType
        Citizen.Wait(50)
        Citizen.InvokeNative(0xCC9C4393523833E2, player, GetHashKey('WEAPON_BOW'), GetHashKey('AMMO_ARROW_DYNAMITE')) --SetPedWeaponAmmoType
        Citizen.Wait(50)
        GiveWeaponToPed_2(player, GetHashKey('WEAPON_LASSO'), 0, false, true, 5, true)
        Citizen.Wait(50)
        -- Citizen.InvokeNative(0x67E21ACC5C0C970C, player, 5, true)
        GiveWeaponToPed_2(player, GetHashKey('WEAPON_SNIPERRIFLE_CARCANO'), 100, false, true, 10, true)
        Citizen.Wait(50)
        GiveWeaponToPed_2(player, GetHashKey('weapon_kit_binoculars'), 0, false, true, -1, true)
        Citizen.Wait(50)
        GiveWeaponToPed_2(player, GetHashKey('weapon_melee_lantern'), 0, false, true, 12, true)
        Citizen.Wait(50)
        GiveWeaponToPed_2(player, GetHashKey('WEAPON_REVOLVER_NAVY'), 100, false, true, 2, true)
        Citizen.Wait(500)
        GiveWeaponToPed_2(player, GetHashKey('weapon_revolver_lemat'), 100, false, true, 3, true)
        -- Citizen.InvokeNative(0x476AE72C1D19D1A8, player, true) --SetPedDropsWeaponsWhenDead
    end)
end)

RegisterCommand("removeweapons", function(source, args, rawCommand)
    Citizen.CreateThread(function()
      RemoveAllPedWeapons(PlayerPedId(), true, true)
    end)
  end)

RegisterCommand('scopetest', function(source, args, rawCommand)
    local players = GetActivePlayers()
    local localPlayerCoords = GetEntityCoords(PlayerPedId())
    for k, player in ipairs(players) do
      local playerId = GetPlayerServerId(player)
      local playerPed = GetPlayerPed(player)
      local playerPedNetId = NetworkGetNetworkIdFromEntity(playerPed)
      local playerPedFromNetId = NetworkGetEntityFromNetworkId(playerPedNetId)
      local playerPedCoords = GetEntityCoords(playerPed)
      local dist = #(localPlayerCoords - playerPedCoords)
      print("Player: "..playerId.." | Ped / NetPed: "..playerPed.." / "..playerPedFromNetId.." | Net: "..playerPedNetId.." | Slot: "..player.." | Dist: "..(math.floor(dist * 10) / 10)..
      " | Pos: ["..(math.floor(playerPedCoords.x * 10) / 10)..","..(math.floor(playerPedCoords.y * 10) / 10)..","..(math.floor(playerPedCoords.z * 10) / 10).."]"..
      " | Sect75: ["..math.floor((playerPedCoords.x+8192.0)/75)..","..math.floor((playerPedCoords.y+8192.0)/75).."]"..
      " | Sect150: ["..math.floor((playerPedCoords.x+8192.0)/150)..","..math.floor((playerPedCoords.y+8192.0)/150).."]")
    end
  end)